# Generated by generate.rb
require 'helper'

describe_moneta "expires_memory" do
  def new_store
    Moneta.build do
      use :Expires
      adapter :Memory
    end
  end

  def load_value(value)
    Marshal.load(value)
  end

  include_context 'setup_store'
  it_should_behave_like 'null_objectkey_objectvalue'
  it_should_behave_like 'null_objectkey_stringvalue'
  it_should_behave_like 'null_objectkey_hashvalue'
  it_should_behave_like 'null_objectkey_booleanvalue'
  it_should_behave_like 'null_stringkey_objectvalue'
  it_should_behave_like 'null_stringkey_stringvalue'
  it_should_behave_like 'null_stringkey_hashvalue'
  it_should_behave_like 'null_stringkey_booleanvalue'
  it_should_behave_like 'null_hashkey_objectvalue'
  it_should_behave_like 'null_hashkey_stringvalue'
  it_should_behave_like 'null_hashkey_hashvalue'
  it_should_behave_like 'null_hashkey_booleanvalue'
  it_should_behave_like 'store_objectkey_objectvalue'
  it_should_behave_like 'store_objectkey_stringvalue'
  it_should_behave_like 'store_objectkey_hashvalue'
  it_should_behave_like 'store_objectkey_booleanvalue'
  it_should_behave_like 'store_stringkey_objectvalue'
  it_should_behave_like 'store_stringkey_stringvalue'
  it_should_behave_like 'store_stringkey_hashvalue'
  it_should_behave_like 'store_stringkey_booleanvalue'
  it_should_behave_like 'store_hashkey_objectvalue'
  it_should_behave_like 'store_hashkey_stringvalue'
  it_should_behave_like 'store_hashkey_hashvalue'
  it_should_behave_like 'store_hashkey_booleanvalue'
  it_should_behave_like 'expires_objectkey_objectvalue'
  it_should_behave_like 'expires_objectkey_stringvalue'
  it_should_behave_like 'expires_objectkey_hashvalue'
  it_should_behave_like 'expires_objectkey_booleanvalue'
  it_should_behave_like 'expires_stringkey_objectvalue'
  it_should_behave_like 'expires_stringkey_stringvalue'
  it_should_behave_like 'expires_stringkey_hashvalue'
  it_should_behave_like 'expires_stringkey_booleanvalue'
  it_should_behave_like 'expires_hashkey_objectvalue'
  it_should_behave_like 'expires_hashkey_stringvalue'
  it_should_behave_like 'expires_hashkey_hashvalue'
  it_should_behave_like 'expires_hashkey_booleanvalue'
  it_should_behave_like 'increment'
  it 'should support default expiration time' do
    store = Moneta.new(:Memory, :expires => 2)
    store.store('key1', 'val1')
    store.store('key2', 'val2', :expires => 60)
    store.load('key1').should == 'val1'
    sleep 1
    store.load('key1').should == 'val1'
    sleep 2
    store.load('key1').should == nil
    store['key2'].should == 'val2'
  end
end
